CTL EQU 1h
SHF EQU	2h
ALT EQU 4h
GUI EQU 8h                                                               


KVAL MACRO key, platform, layer
  IFDEF _MOD_&key&_&platform&_&layer
	DB _MOD_&key&_&platform&_&layer                                        
  ELSE 
  	  IFDEF _MOD_&key&_&PC&_&layer
    	DB _MOD_&key&_&PC&_&layer                    
      ELSE
      	DB 0                              
      ENDIF
  ENDIF
  
  IFDEF _HID_&key&_&platform&_&layer              
  	DB _HID_&key&_&platform&_&layer
  ELSE                                         
  	  IFDEF _HID_&key&_pc&_&layer
		DB _HID_&key&_pc&_&layer
	  ELSE 
	  	DB 0
	  ENDIF
  ENDIF
ENDM

MODEF MACRO modVal

ENDM

KEY MACRO key, hidPCTop, modPCTop, hidPCFun, modPCFun, hidPCNum, modPCNum, hidMacTop, modMacTop, hidMacFun, modMacFun, hidMacNum, modMacNum
	
	IFNB <hidPCTop>
		_HID_&key&_pc_top EQU hidPCTop
	ELSE
		$ERROR('Top PC layer cannot be blank')		
	ENDIF
	
	IFNB <modPCTop>
		_MOD_&key&_pc_top EQU modPCTop
	ENDIF
	
	IFNB <hidPCFun>
		_HID_&key&_pc_fun EQU hidPCFun
	ENDIF
	
	IFNB <modPCFun>
		_MOD_&key&_pc_fun EQU modPCFun
	ENDIF
	
	IFNB <hidPCNum>
		_HID_&key&_pc_num EQU hidPCNum
	ENDIF
	
	IFNB <modPCNum>
		_MOD_&key&_pc_num EQU modPCNum
	ENDIF
	
	IFNB <hidMacTop>
		_HID_&key&_mac_top EQU hidMacTop
	ENDIF	
	
	IFNB <modMacTop>
		_MOD_&key&_mac_top EQU modMacTop
	ENDIF
	
	IFNB <hidMacFun>
		_HID_&key&_mac_fun EQU hidMacFun
	ENDIF			
	
	IFNB <modMacFun>
		_MOD_&key&_mac_fun EQU modMacFun
	ENDIF	
	
	IFNB <hidMacNum>
		_HID_&key&_mac_num EQU hidMacNum
	ENDIF		
	
	IFNB <modMacNum>
		_MOD_&key&_mac_num EQU modMacNum
	ENDIF	

ENDM

KEYMATRIX MACRO platform, lyr
	
	;row1
	DW 0000h 		
    DW 0000h 		
    KVAL K4_8, platform, lyr
    DW 0000h 		
    DW 0000h 		
    KVAL K3_1, platform, lyr
    KVAL K3_2, platform, lyr
    DW 0000h
    
    ;row2
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h
    
    ;row3
    KVAL K5_2, platform, lyr
    KVAL K3_4, platform, lyr
    KVAL K5_7, platform, lyr
    KVAL K3_8, platform, lyr
    KVAL K3_3, platform, lyr
    KVAL K4_3, platform, lyr
    KVAL K6_2, platform, lyr
    DW 0000h
    
    ;row4
    KVAL K7_15, platform, lyr
    DW 0000h 		
    KVAL K2_1, platform, lyr
    KVAL K7_9, platform, lyr
    DW 0000h 		
    KVAL K6_1, platform, lyr
    KVAL K6_13, platform, lyr
    DW 0000h
    
    ;row5
    DW 0000h 		
    KVAL K7_13, platform, lyr
    DW 0000h 		
    KVAL K7_7, platform, lyr
    KVAL K7_11, platform, lyr
    DW 0000h 		
    DW 0000h 		
    DW 0000h
    
    ;row6
    KVAL K7_2, platform, lyr
    DW 0000h 		
    DW 0000h 		
    KVAL K2_3, platform, lyr
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    KVAL K7_14, platform, lyr
    ;row7
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 	
    KVAL K5_1, platform, lyr
    KVAL K5_13, platform, lyr
    DW 0000h 
    
    ; row 8
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    KVAL K2_2, platform, lyr
    KVAL K7_1, platform, lyr
    DW 0000h 		
    DW 0000h
    
    ; row 9
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 
    
    ; row 10
    KVAL K4_4, platform, lyr
    KVAL K1_2, platform, lyr
    KVAL K7_5, platform, lyr
    KVAL K1_3, platform, lyr
    KVAL K7_4, platform, lyr
    KVAL K1_1, platform, lyr
    KVAL K6_3, platform, lyr
    KVAL K5_3, platform, lyr
    
    ; row 11
    DW 0000h 		
    KVAL K1_4, platform, lyr
    KVAL K1_14, platform, lyr
    KVAL K1_5, platform, lyr
    DW 0000h 		
    DW 0000h 		
    DW 0000h 		
    DW 0000h 
    
    ; row 12
    KVAL K5_4, platform, lyr
    KVAL K3_5, platform, lyr
    KVAL K4_5, platform, lyr
    KVAL K3_11, platform, lyr
    KVAL K4_11, platform, lyr
    KVAL K5_10, platform, lyr
    KVAL K6_10, platform, lyr
    KVAL K6_4, platform, lyr
    
    ; row 13
    KVAL K5_6, platform, lyr
    KVAL K3_6, platform, lyr
    KVAL K4_7, platform, lyr
    KVAL K3_7, platform, lyr
    KVAL K4_6, platform, lyr
    KVAL K5_5, platform, lyr
    KVAL K6_6, platform, lyr
    KVAL K6_5, platform, lyr
    
    ; row 14
    KVAL K5_9, platform, lyr
    KVAL K3_9, platform, lyr
    KVAL K4_10, platform, lyr
    KVAL K3_10, platform, lyr
    KVAL K4_9, platform, lyr
    KVAL K5_8, platform, lyr
    KVAL K6_9, platform, lyr
    KVAL K6_8, platform, lyr
    
    ; row 15
    KVAL K4_1, platform, lyr
    KVAL K1_6, platform, lyr
    KVAL K7_8, platform, lyr
    KVAL K1_7, platform, lyr
    KVAL K3_15, platform, lyr
    KVAL K4_15, platform, lyr
    KVAL K6_7, platform, lyr
    KVAL K7_10, platform, lyr
    
    ; row 16
    KVAL K4_14, platform, lyr
    KVAL K1_8, platform, lyr
    KVAL K3_14, platform, lyr
    KVAL K1_9, platform, lyr
    KVAL K3_12, platform, lyr
    KVAL K4_12, platform, lyr
    KVAL K6_11, platform, lyr
    KVAL K5_11, platform, lyr
    
    ; row 17
    KVAL K6_12, platform, lyr
    KVAL K1_10, platform, lyr
    KVAL K7_12, platform, lyr
    KVAL K1_11, platform, lyr
    KVAL K3_13, platform, lyr
    KVAL K5_12, platform, lyr
    KVAL K4_13, platform, lyr
    KVAL K4_2, platform, lyr
    
    ; row 18
    DW 0000h 		
    KVAL K1_12, platform, lyr
    KVAL K7_6, platform, lyr
    KVAL K1_13, platform, lyr
    KVAL K7_3, platform, lyr
    DW 0000h 		
    DW 0000h 		
    DW 0000h 
    
ENDM







