
do_keypad:                                      ;void __interrupt keypad() {
    PUSH ACC
    PUSH DPH
    PUSH DPL
    PUSH PSW
    MOV PSW, #10h           ;   // use register bank 2
    MOV R0, #1h
    MOVX A, @R0
    MOV 0E1h, A             ;   WDTCR = wdtcr; // Watch-dog Timer
    MOV 0D5h, #0FFh         ;   KBPATN = 0xFF;
    MOV 0D6h, #0h           ;   KBCON = 0;
    MOV 0D7h, #0h           ;   KBMASK = 0;
L0234:                                          ;   do {
    MOV A, 0BFh
    JNB ACC.1, L0234        ;   } while (not CKCON2.PLL_RDY);
    MOV R0, #14h
    MOVX A, @R0
    JZ L0235                ;   if (remote_wakeup != 0) {
    MOV DPTR, #UPCON
    MOVX A, @DPTR
    ORL A, #20h
    MOVX @DPTR, A           ;       UPCON.URWU = true; // 0x20 USB Remote Wake-Up Trigger
L0235:                                          ;   }
    MOV R7, #4h
    LCALL delay             ;   delay(4);
L0236:                                          ;   do {
    MOV DPTR, #ACKCTL
    MOVX A, @DPTR
    ORL A, #2h
    MOVX @DPTR, A           ;       USB_CC.1 = true;
    MOVX A, @DPTR
    JNB ACC.1, L0236        ;   } while (not USB_CC.1);
    MOV R0, #14h
    MOVX A, @R0
    JZ L0237                ;   if (remote_wakeup != 0) {
    MOV DPTR, #UPCON
    MOVX A, @DPTR
    ORL A, #20h
    MOVX @DPTR, A           ;       UPCON.URWU = true; // 0x20 USB Remote Wake-Up Trigger
L0237:                                          ;   }
    POP PSW
    POP DPL
    POP DPH
    POP ACC
    RETI                    ;} // keypad
