
find_macro:                                     ;bool __register(C) find_macro(byte* __register(R0) p) {
    MOV A, @R0
    ADD A, #4Dh
    MOV R0, A
    MOV A, @R0
    MOV R0, #keyCode
    MOV @R0, A              ;   keycode = keys_down[*p];
    CLR A
    MOV R0, #59h
    MOV @R0, A
    INC R0
    MOV @R0, A              ;   macro = NULL;
    MOV R0, #keyCode
    MOV A, @R0
    JNZ L0084
    LJMP L0085              ;   if (keycode == 0) return false;

L0084:
    RRC A
    RRC A
    RRC A
    ANL A, #1Fh
    MOV DPTR, #02800h
    MOVC A, @A+DPTR
    MOV R0, #56h
    MOV @R0, A              ;   v56 = macros.disabled[keycode >> 3];
    MOV R0, #keyCode
    MOV A, @R0
    ANL A, #7h
    MOV R1, #53h
    MOV @R1, A              ;   v53 = keycode & 7;
    MOV R0, #53h
    MOV A, @R0
    MOV R7, A
    MOV R0, #56h
    MOV A, @R0
    MOV R6, A
    XCH A, R0
    MOV A, R7
    XCH A, R0
    INC R0
    SJMP L0086

L0087:
    CLR C
    RRC A
L0086:
    DJNZ R0, L0087
    JNB ACC.0, L0088
    LJMP L0085              ;   if ((v56 >> v53) & 0x01) return false;

L0088:
    MOV DPTR, #02820h
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #56h
    MOV @R0, A              ;   byte __volatile(v56) n = macros.binding_count;
    INC R0
    MOV @R0, #28h
    INC R0
    MOV @R0, #21h
    CLR A
    MOV R0, #54h
    MOV @R0, A
L0094:                                          ;   for (byte __volatile(v54) i = 0, word __volatile(vw57) pBinding = &macros.bindings[0]; i < n; ++pBinding, ++i) {
    MOV R1, #54h
    MOV A, @R1
    CLR C
    MOV R0, #56h
    SUBB A, @R0
    JC L0089
    LJMP L0085

L0089:
    INC R0
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #keyCode
    XRL A, @R0
    JNZ L0090               ;       if (pBinding->keycode != keycode) continue;
    MOV R0, #4Bh
    MOV A, @R0
    ANL A, #7h
    MOV R7, A
    MOV R0, #3Fh
    MOV @R0, A              ;       byte __volatile(v3F) modifiers = R7 = key_modifiers & (LAlt | LShift | LCtrl);
    MOV R0, #4Bh
    MOV A, @R0
    SWAP A
    ANL A, #7h
    ORL A, R7
    MOV R0, #3Fh
    MOV @R0, A              ;       modifiers = R7 | (key_modifiers >> 4) & (LAlt | LShift | LCtrl);
    CLR A
    MOV R0, #53h
    MOV @R0, A
L0093:                                          ;       for (byte __volatile(v53) j = 0; j != 8; ++pBinding, ++j) {
    MOV R0, #57h
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #keyCode
    XRL A, @R0
    JNZ L0091               ;           if (pBinding->keycode != keycode) return false;
    INC A
    MOVC A, @A+DPTR
    MOV R0, #3Fh
    XRL A, @R0
    JNZ L0092               ;           if (pBinding->modifiers != modifiers) continue;
    MOV R0, #57h
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    MOV A, #2h
    MOVC A, @A+DPTR
    INC R0
    MOV @R0, A
    MOV R0, #57h
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    MOV A, #3h
    MOVC A, @A+DPTR
    MOV R0, #5Ah
    MOV @R0, A              ;           pMacro = pBinding->pItems;
    MOV R0, #57h
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    MOV A, #4h
    MOVC A, @A+DPTR
    MOV R0, #40h
    MOV @R0, A              ;           macro_delay_after = pBinding->delay_after;
    SETB C
    RET                     ;           return true;

L0091:
    CLR C
    RET

L0092:
    MOV R0, #58h
    MOV A, #5h
    ADD A, @R0
    MOV @R0, A
    DEC R0
    CLR A
    ADDC A, @R0
    MOV @R0, A
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    XRL A, #8h
    JNZ L0093               ;       } // for j
    CLR C
    RET                     ;       return false; // found keycode, did not find modifiers

L0090:
    MOV R0, #58h
    MOV A, #5h
    ADD A, @R0
    MOV @R0, A
    DEC R0
    CLR A
    ADDC A, @R0
    MOV @R0, A
    MOV R0, #54h
    INC @R0
    LJMP L0094

L0085:                                          ;   } // for i
    CLR C
    RET                     ;   return false; // did not find keycode
                            ;}
                            

play_macro:                                     ;void play_macro() {
    MOV R0, #59h
    MOV A, @R0
    MOV R7, A
    INC R0
    MOV A, @R0
    MOV R0, #57h
    LJMP L0055

L0056:                                          ;   for (;;) {
    MOV R0, #59h
    MOV A, @R0
    MOV R6, A
    INC R0
    MOV A, @R0
    MOV DPL, A
    MOV DPH, R6
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #55h
    MOV @R0, A              ;       byte __volatile(v55) n = pMacro->count;
    MOV R0, #5Ah
    INC @R0
    MOV A, @R0
    DEC R0
    JNZ L0057
    INC @R0                 ;       pMacroEvent = &pMacro->items[0];
L0057:
    CLR A
    MOV R0, #56h
    MOV @R0, A              ;       v56 = 0;
    MOV R0, #54h
    MOV @R0, A
L0079:
    MOV R1, #54h
    MOV A, @R1
    CLR C
    MOV R0, #55h
    SUBB A, @R0
    JC L0058                ;       for (byte __volatile(v54) j = 0; j < n; ++j) {
    LJMP L0059

L0058:
    CLR EA                  ;           __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #1h
    MOVX @DPTR, A           ;               EPINDEX = 1;
    CLR A
    MOV R0, #53h
    MOV @R0, A
L0068:                                          ;               for (byte __volatile(v53) i = 0; i < 8; ++i) {
    MOV R0, #53h
    MOV A, @R0
    MOV R7, A
    CLR C
    SUBB A, #8h
    JNC L0067

    MOV A, R7
    MOV R0, #5Ah
    ADD A, @R0
    MOV R7, A
    CLR A
    DEC R0
    ADDC A, @R0
    MOV DPL, R7
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    MOV DPTR, #TXDAT
    MOVX @DPTR, A           ;                   TXDAT = pMacroEvent->hid_report[i];
    MOV R0, #53h
    INC @R0
    SJMP L0068              ;               }

L0067:
    MOV R0, #53h
    MOV A, @R0
    MOV R0, #5Ah
    ADD A, @R0
    MOV R7, A
    CLR A
    DEC R0
    ADDC A, @R0
    MOV DPL, R7
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #42h
    MOV @R0, A              ;               LOBYTE(macro_delay) = LOBYTE(pMacroEvent->delay);
    MOV R0, #53h
    INC @R0                 ;               ++i; // 9
    MOV A, @R0
    MOV R0, #5Ah
    ADD A, @R0
    MOV R7, A
    CLR A
    DEC R0
    ADDC A, @R0
    MOV DPL, R7
    MOV DPH, A
    CLR A
    MOVC A, @A+DPTR
    MOV R0, #41h
    MOV @R0, A              ;               HIBYTE(macro_delay) = HIBYTE(pMacroEvent->delay) | pMacroEvent->flags;
    MOV A, @R0
    ANL A, #0F0h
    MOV R1, #44h
    MOV @R1, A              ;               after_macro = pMacroEvent.flags;
    MOV A, @R0
    ANL A, #0Fh
    MOV @R0, A              ;               HIBYTE(macro_delay) = HIBYTE(pMacroEvent->delay);
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;               usb1_transmitting = 1;

                            ;               // FIXME:
    MOV R0, #53h            ;               // 00   NOP
    MOV A, @R0              ;               // 7408 MOV A, #08h

    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;               TXCNT = i; // 9??
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;               EPINDEX = 0;
    SETB ENABLE_ANY                 ;           }
L0069:                                          ;           do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0069                ;           } while (usb1_transmitting == 1);
    MOV R0, #5Ah
    MOV A, #0Ah
    ADD A, @R0
    MOV @R0, A
    DEC R0
    CLR A
    ADDC A, @R0
    MOV @R0, A              ;           ++pMacroEvent; // to found->items[j+1]
    MOV R0, #43h
    MOV @R0, #15h           ;           usb_intr_count = 0x15; // 21
L0070:                                          ;           do {
    MOV R0, #43h
    MOV A, @R0
    JNZ L0070               ;           } while (usb_intr_count); // wait for 21 USB interrupts?
    MOV R0, #44h
    MOV A, @R0
    JB ACC.7, L0071         ;           if (not after_macro.7) {
    CLR EA                  ;               __uninterrupted {
    MOV DPTR, #EPINDEX
    MOV A, #1h
    MOVX @DPTR, A           ;                   EPINDEX = 1;
    CLR A
    MOV R0, #53h
    MOV @R0, A
L0072:                                          ;                   for (byte __volatile(v53) i = 0; i != 8; ++i) {
    MOV DPTR, #TXDAT
    CLR A
    MOVX @DPTR, A           ;                       TXDAT = 0;
    MOV R0, #53h
    INC @R0
    MOV A, @R0
    CJNE A, #8h, L0072      ;                   }
    MOV R0, #usbTXBusy
    MOV @R0, #1h            ;                   usb1_transmitting = 1;
    MOV R0, #53h
    MOV A, @R0
    MOV DPTR, #TXCNT
    MOVX @DPTR, A           ;                   TXCNT = i; // 8
    MOV DPTR, #EPINDEX
    CLR A
    MOVX @DPTR, A           ;                   EPINDEX = 0;
    SETB ENABLE_ANY                 ;               }
L0073:                                          ;               do {
    MOV R0, #usbTXBusy
    MOV A, @R0
    XRL A, #1h
    JZ L0073                ;               } while (usb1_transmitting == 1);
L0071:                                          ;           } // if after_macro.7
    MOV R0, #42h
    MOV A, @R0
    DEC R0
    ORL A, @R0
    JZ L0074                ;           if (macro_delay) {
    MOV R0, #43h
    MOV @R0, #32h           ;               usb_intr_count = 0x32; // 50
L0075:                                          ;               do {
    MOV R0, #43h
    MOV A, @R0
    JNZ L0075               ;               } while (usb_intr_count);
    MOV R0, #42h
    MOV A, @R0
    DEC @R0
    DEC R0
    JNZ L0076
    DEC @R0                 ;               --macro_delay;
L0076:
    MOV R0, #42h
    MOV A, @R0
    DEC R0
    ORL A, @R0
    JZ L0074                ;               if (macro_delay) {
    MOV R0, #43h
    MOV @R0, #32h           ;
L0078:                                          ;                   for (usb_intr_count = 0x32 /*50*/; usb_intr_count; ) {
    MOV R0, #43h
    MOV A, @R0
    JZ L0077
    MOV R0, #56h
    MOV A, @R0
    JNZ L0078               ;                       if (v56 == 0)
    MOV R7, #12h
    LCALL read_column
    MOV R0, #56h
    MOV A, R7
    MOV @R0, A              ;                           v56 = read_column(sizeof(key_matrix));
    SJMP L0078              ;                   }

L0077:
    MOV R0, #42h
    MOV A, @R0
    DEC @R0
    DEC R0
    JNZ L0076
    DEC @R0                 ;                   --macro_delay;
    SJMP L0076

L0074:                                          ;           }   }
    MOV R0, #54h
    INC @R0
    LJMP L0079

L0059:                                          ;       } // for j
    MOV R0, #40h
    MOV A, @R0
    JNZ L0060               ;       if (macro_delay_after == 0)
    SETB C
    RET                     ;           return true;

L0060:
    MOV R0, #56h
    MOV A, @R0
    JZ L0061                ;       if (v56 != 0)
    SETB C
    RET                     ;           return true;

L0061:
    MOV R0, #43h
    MOV @R0, #32h           ;
L0064:                                          ;       for (usb_intr_count = 0x32 /*50*/; usb_intr_count; ) {
    MOV R0, #43h
    MOV A, @R0
    JZ L0062
    MOV R7, #12h
    LCALL read_column
    MOV R0, #56h
    MOV A, R7
    MOV @R0, A              ;           v56 = read_column(sizeof(key_matrix));
    JZ L0064                ;           if (v56)
    SETB C
    RET                     ;               return true;

L0062:                                          ;       }
    MOV R0, #43h
    MOV @R0, #32h
L0066:                                          ;       for (usb_intr_count = 0x32 /*50*/; usb_intr_count; ) {
    MOV R0, #43h
    MOV A, @R0
    JZ L0065
    MOV R7, #12h
    LCALL read_column
    MOV R0, #56h
    MOV A, R7
    MOV @R0, A              ;           v56 = read_column(sizeof(key_matrix));
    JZ L0066                ;           if (v56)
    SETB C
    RET                     ;               return true;

L0065:                                          ;       }
    MOV R0, #57h
    MOV A, @R0
    MOV R7, A
    INC R0
    MOV A, @R0
    INC R0
L0055:
    XCH A, R7
    MOV @R0, A
    INC R0
    MOV A, R7
    MOV @R0, A
    LJMP L0056              ;}  }